<?php
/* Version 12.0.0.7
Modified by Steven Davis for TNG */
$location = ("../../");
include($location."begin.php");
include($location."adminlib.php");
include($location."getlang.php");
include($location."$mylanguage/admintext.php");
$blacklist = $location."blacklist.dat";
$robotstxt = $location."robots.txt";
$htaccess = $location.".htaccess";
$bt_check_msg = "";

/* The section below checks the server OS and version.
 * If you are running Apache 2.4 and the mod does not
 * install, comment out the section below */
$version = $_SERVER['SERVER_SOFTWARE'];
if (!empty($version))
{
	echo "<p>Server: $version</p>";
	$backend = explode('/', $version);
	$backend = $backend[0];
	if (stristr($backend, 'nginx'))
	{
		echo "<p>This mod requires Apache Server</p>";
		exit;
	}
	elseif (stristr($backend, 'apache'))
	{
		$version = filter_var($version, FILTER_SANITIZE_NUMBER_INT);
		if(substr($version, 0, 2) < 24)
		{
			echo "<p>Bot-Trap v12.0.0.7 requires Apache v2.4 or higher</p>";
			exit;
		}
	}
}
/* End of Check Server Section */


if (!is_dir($location."bot-trap"))
{
	mkdir($location."bot-trap");
	$bt_check_msg .="<p>The directory 'bot-trap' has been created.</p>";
}
else
{
	$bt_check_msg .="<p>The directory 'bot-trap' already exists.</p>";
}

if (file_exists($blacklist))
{
    $bt_check_msg .="<p>The file 'blacklist.dat' already exists.</p>";
}
else
{
		$fh = fopen($blacklist,"x+b");
		fclose($fh);
		chmod($blacklist,0664);
		$bt_check_msg .="<p>The file 'blacklist.dat' has been created.</p>";
}

if (file_exists($robotstxt))
{
	$key = "User-agent: *";
	$key1 = "Disallow: /bot-trap/";
	$fh = fopen($robotstxt,"r");
	$lines = file($robotstxt);
	fclose($fh);
    foreach($lines as $line)
	{
        if (stristr($line, $key)) $agent=true;
		if (stristr($line, $key1)) //look for bot-trap in each line
		{
			$bt_check_msg .="<p>The file 'robots.txt' already exists.</p>";
			break;
		}
	}

	if (!stristr($line, $key1))
	{
		$fh = fopen($robotstxt,"w+");
			if (!$agent)
			{
				fwrite($fh, $key."\r\n".$key1."\r\n"); //insert disallow bot-trap after User-agent;
			}
			foreach($lines as $line)
			{
				fwrite($fh, $line); //place lines back in file
				if ( stristr($line, $key) && ($agent) && !$disallowbt) //look for user agent in each line
				{
					fwrite($fh, $key1."\r\n"); //insert disallow bot-trap after User-agent one time;
					$disallowbt = 1;
				}
			}
			fclose($fh);
			$bt_check_msg .="<p>The file 'robots.txt' was modified to add 'Disallow: /bot-trap'.</p>";
	}
}

if (!file_exists($robotstxt))
{
		$fh = fopen($robotstxt,"w");
		fwrite($fh,"User-agent: *\r\nDisallow: /bot-trap/");
		fclose($fh);
		chmod($robotstxt,0664);
		$bt_check_msg .="<p>The file 'robots.txt' has been created.</p>";
}

if (file_exists($htaccess))
{
	$key = "</RequireAll>";
	$forbid = "ErrorDocument 403 /bot-trap/forbid.php";
	$fh = fopen($htaccess,'r');
	$lines = file($htaccess);
	fclose($fh);
	
    foreach($lines as $line)
	{
        if (stristr($line, $key)) //see if RequireAll exists
		{
			$bt_check_msg .=  "<p>The file '.htaccess' already exists.</p>";
			break;
		}
		elseif ( $line == end($lines) )
		{
			$fh = fopen($htaccess,'a+');
			fwrite($fh, "\n"."# Access file for Apache 2.4 - Modified by Bot-trap\r\n<RequireAll>\n"."	Require all granted\n"."    # Anything below this line was added by Bot-trap"."\n</RequireAll>");
			fclose($fh);
			$bt_check_msg .="<p>The file '.htaccess' has been modified.</p>";
			break;
		}
	}
}

if (!file_exists($htaccess))
{
	$fh = fopen($htaccess,"x+");
	fwrite($fh, "# Access file for Apache 2.4 - Created by Bot-trap\r\n<RequireAll>\n"."	Require all granted\n"."    # Anything below this line was added by Bot-trap\n</RequireAll>");
	fclose($fh);
	chmod($htaccess,0664);
	$bt_check_msg .="<p>The file '.htaccess' has been created.</p>";
}
echo $bt_check_msg."<p>You may close this window and proceed with installation.</p>";
?>